unit userielb;
interface
uses crt,dos{,utimer},ubuf;

const br110 =        0;
      br150 =       32;
      br300 =    64   ;
      br600 =    64+32;
      br1200=128      ;
      br2400=128+   32;
      br4800=128+64   ;
      br9600=128+64+32;

      none=0;
      odd=4;
      even=8+4;

      bits7=2;
      bits8=1+2;

      stop1=0;
      stop2=4;

      com1=0;
      com2=1;

      stTimeOut=128;
type TSeriellb=object
       gepuffert:boolean;
       procedure init(com:byte;ial:byte;agepuffert:boolean);
       procedure send(com:byte;c:char);
       function recv(com:byte;var c:char):byte;
       function status(com:byte):byte;
       procedure setinterrupt(icom:byte;asize,amaxdelay:word);
       function bufvoll:boolean;
     end;

implementation
var oldex:pointer;
    com_intr_nr,com:byte;
    com_base:word;
    oldcom_intr_vect:pointer;
    buf:Pbuf;
    maxdelay:word;

const intgesetzt:boolean=false;
      
  Intr_Contr      = $20;    { I-O-address of 8259-command-register }
  Intr_Contr_Mask = $21;    { I-O-address of 8259-interrupt-mask }
  Com1_Intr_Nr    = $0C;
  Com2_Intr_Nr    = $0B;
  Timer_Intr_Nr   = $1C;
  Com1_Base_addr:word  = $03F8;
  Com2_Base_addr:word = $02F8;
  EOI             = $20;   { non-specific end of interrupt value }

procedure TSeriellb.init(com:byte;ial:byte;agepuffert:boolean);
var regs:registers;
begin
  gepuffert:=agepuffert;
  with regs do begin
    dx:=com;
    ah:=0;
    al:=ial;
    intr($14,regs);
  end;
  if gepuffert then setinterrupt(com,60000,500);
end;

procedure TSeriellb.send(com:byte;c:char);
var regs:registers;
    state:byte;
    check:word;
begin
  if gepuffert then begin
    state:= 0;
    check:=0;
    WHILE (state = 0) and (check<60000) DO begin
      state:= Port[com_base+5] and $20;
      inc(check);
    end;
    Port[com_base]:= byte(c);
  end else with regs do begin
    dx:=com;
    ah:=1;
    al:=byte(c);
    intr($14,regs);
  end;
end;

function TSeriellb.recv(com:byte;var c:char):byte;
var regs:registers;
    h:byte;
    t:word;
begin
  if gepuffert then begin
    if buf=nil then begin
      recv:=sttimeout;
      exit;
    end;
    if buf^.get(h) then begin
      recv:=0;
      c:=char(h);
    end else begin
      t:=0;
      repeat
        delay(1);
        inc(t);
      until buf^.get(h) or (t>maxdelay);
      if t>maxdelay then recv:=sttimeout else begin
        recv:=0;
        c:=char(h);
      end;
    end;
  end else with regs do begin
    dx:=com;
    ah:=2;
    intr($14,regs);
    c:=char(al);
    recv:=ah;
  end;
end;

function TSeriellb.status(com:byte):byte;
var regs:registers;
begin
  with regs do begin
    dx:=com;
    ah:=3;
    intr($14,regs);
    status:=ah;
  end;
end;


PROCEDURE ReceiveSerial; interrupt;
BEGIN
  if buf<>nil then buf^.put(Port[Com_Base]);
  Port[Intr_Contr]:= EOI;
END;

{PROCEDURE ReceiveSerialtimer;far;
var c:char;
BEGIN
  asm cli end;
  if (buf<>nil) and ((recv(com,c) and stTimeOut)=0) then
    buf^.put(byte(c));
  asm sti end;
END;}

PROCEDURE EnableSerIrq;
VAR
  b,dummy: Byte;
BEGIN
  GetIntVec( com_intr_nr, oldcom_intr_vect);
  SetIntVec( com_intr_nr, @ReceiveSerial);
  { Enable 8259-interrupt-mask for serial interface. }
  Port[ com_base+1]:= $01;
  Port[ com_base+4]:= $0B;
  dummy:= Port[ com_base];
  { Enable receive-data-interrupt on 8259-controller.}
  b:= Port[Intr_Contr_Mask];
  b:= b and $E7;
  Port[Intr_Contr_Mask]:= b;
END;

PROCEDURE DisableSerIrq;
VAR
  b: Byte;
BEGIN
  { Reset 8259-interrupt-mask for serial interface. }
  Port[com_base+4]:= 0;
  { Disable receive-data-interrupt on 8259-controller. }
  b:= Port[Intr_Contr_Mask];
  b:= b or $18;
  Port[Intr_Contr_Mask]:= b;
  SetIntVec( com_intr_nr, oldcom_intr_vect);
END;

function TSeriellb.bufvoll:boolean;
begin
  bufvoll:=buf^.aktsize>0;
end;

procedure TSeriellb.setinterrupt(icom:byte;asize,amaxdelay:word);
{var empfang:proc;}
begin
  com:=icom;
  maxdelay:=amaxdelay;
  new(buf,init(asize));
  if com=com1 then begin
    com_intr_nr:= Com1_Intr_Nr;
    com_base:=com1_base_addr;
  end else begin
    com_intr_nr:= Com2_Intr_Nr;
    com_base:=com2_base_addr;
  end;
  EnableSerIrq;
{  empfang:=ReceiveSerialtimer;
  SetTimer(empfang,800);}
  intgesetzt:=true;
end;

procedure myex;far;
begin
  exitproc:=oldex;
  if intgesetzt then begin
    dispose(buf,done);
    DisableSerIrq;
  end;
end;

begin
  Com1_Base_addr:=Memw[$40:0];
  Com2_Base_addr:=Memw[$40:2];
  oldex:=exitproc;
  exitproc:=@myex;
  buf:=nil;
end.